"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  usePrevious: true,
  useInit: true
};
exports.useInit = exports.usePrevious = void 0;

function _react() {
  const data = _interopRequireWildcard(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

var _terminal = require("./terminal");

Object.keys(_terminal).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _terminal[key];
    }
  });
});

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

const usePrevious = value => {
  const ref = (0, _react().useRef)();
  (0, _react().useEffect)(() => {
    ref.current = value;
  }, [value]);
  return ref.current;
};

exports.usePrevious = usePrevious;

const useInit = dep => {
  const _useState = (0, _react().useState)(false),
        _useState2 = _slicedToArray(_useState, 2),
        init = _useState2[0],
        setInit = _useState2[1];

  (0, _react().useEffect)(() => {
    if (init || Object.keys(dep).length === 0) {
      return;
    }

    setInit(true);
  }, [dep]);
  return [init];
};

exports.useInit = useInit;